#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	leaveok

#ifndef	NDEBUG
char *rcsid_leaveok = "$Header: c:/curses/portable/RCS/leaveok.c%v 2.0 1992/11/15 03:28:59 MH Rel $";
#endif




/*man-start*********************************************************************

  leaveok()	- enable non-tracking cursor

  X/Open Description:
 	Normally, the hardware cursor is left at the location of the
 	window being refreshed.  This option allows the cursor to be
 	left whereever the update happens to leave it.  It is useful
 	for applications where the cursor is not used, since it reduces
 	the need for cursor motions.  If possible, the cursor is made
 	invisible when this option is enabled.

  PDCurses Description:
 	Though not explicitly stated, the cursor will be made visible
 	again, if leaveok() is passed a FALSE value.
 			(Frotz:911226 Comments?)

  X/Open Return Value:
 	The leaveok() function returns OK on success and ERR on error.

  X/Open Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	int leaveok( WINDOW* win, bool bf );
 	X/Open Dec '88	int leaveok( WINDOW* win, bool bf );
 	BSD Curses	int leaveok( WINDOW* win, bool bf );
 	SYS V Curses	int leaveok( WINDOW* win, bool bf );

**man-end**********************************************************************/

int	leaveok( WINDOW *win, bool bf )
{
	if  ((win->_leave = bf) != 0)	cursoff();
	else				curson();
	return( OK );
}
